import gtk
import gobject


#
# Dialog for alarms.
#
class AlarmDialog(gtk.MessageDialog):

    #
    # Constructor.
    #
    def __init__(self, events):

        gtk.MessageDialog.__init__(self, None, 0,
                                   gtk.MESSAGE_WARNING,
                                   gtk.BUTTONS_OK,
                                   _("Do not forget:"))
        self.set_title(_("Appointment Reminder"))
        self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
        self.connect("delete-event", self.__on_close)

        # close button
        self.connect("response", self.__on_close)
                
        self.set_keep_above(True)

        import icon
        img = self.get_children()[0].get_children()[0].get_children()[0]
        img.set_from_pixbuf(icon.ICON)

        msg = ""
        for ev in events:
            ev.set_alarm(-1)
            text = ev.get_summary()
            
            # escape certain characters for Pango
            text = text.replace("&", "&amp;")
            text = text.replace("<", "&lt;")
            text = text.replace(">", "&gt;")
            text = text.replace("\\\"", "\"")
        
            estart = ev.get_start()
            shour, smin, ssec = estart.get_daytime()
            if (estart.has_daytime()):
                etime = "%(shour)02d:%(smin)02d" % vars()
            else:
                etime = "--:--"                

            msg += "<b><tt>%s</tt></b>   %s\n" % (etime, text)
        self.format_secondary_markup(msg)        


    #
    # Reacts on closing the window.
    #
    def __on_close(self, *args):
 
        self.destroy()
        return True
